<?php

namespace Builderius\Bundle\ACFBundle\GraphQL\Resolver;

use Builderius\Bundle\GraphQLBundle\Resolver\GraphQLFieldResolverInterface;
use Builderius\GraphQL\Type\Definition\ResolveInfo;

class ACFFieldObjectResolver implements GraphQLFieldResolverInterface
{
    private $typeNames;

    /**
     * @param array $typeNames
     */
    public function __construct(
        array $typeNames
    )
    {
        $this->typeNames = $typeNames;
    }

    /**
     * @inheritDoc
     */
    public function getTypeNames()
    {
        return $this->typeNames;
    }

    /**
     * @inheritDoc
     */
    public function getFieldName()
    {
        return 'acf_field_object';
    }

    /**
     * @inheritDoc
     */
    public function getSortOrder()
    {
        return 10;
    }

    /**
     * @inheritDoc
     */
    public function isApplicable($objectValue, array $args, $context, ResolveInfo $info)
    {
        return true;
    }

    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        try {
            return acf_get_field($args['name']);
        } catch (\Exception $e) {
            return null;
        }
    }
}