<?php

namespace Builderius\Bundle\ACFBundle\GraphQL\Resolver;

use Builderius\GraphQL\Type\Definition\ResolveInfo;

class ACFRepeaterValueResolver extends AbstractACFValueResolver
{
    /**
     * @inheritDoc
     */
    public function resolve($objectValue, array $args, $context, ResolveInfo $info)
    {
        if (!isset($args['name'])) {
            return null;
        }
        if (!$this->isOption && !$objectValue->ID) {
            return null;
        }
        $val = get_field($args['name'], $this->getOwnerId($objectValue));
        if (!is_array($val)) {
            return [];
        }

        return $val;
    }
}