<?php

namespace Builderius\Bundle\BuilderBundle\Hook;

use Builderius\MooMoo\Platform\Bundle\HookBundle\Model\AbstractAction;
use Builderius\MooMoo\Platform\Bundle\KernelBundle\Provider\PluginsVersionsProvider;

class ShowChangelogAdminNoticeHook extends AbstractAction
{
    /**
     * @var PluginsVersionsProvider
     */
    private $pluginsVersionsProvider;

    /**
     * @param PluginsVersionsProvider $pluginsVersionsProvider
     */
    public function setPluginsVersionsProvider(PluginsVersionsProvider $pluginsVersionsProvider)
    {
        $this->pluginsVersionsProvider = $pluginsVersionsProvider;
    }

    /**
     * @inheritDoc
     */
    public function getFunction()
    {
        $user_id = get_current_user_id();
        $dismissedChangelog = get_user_meta($user_id, 'builderius_changelog_notice_dismissed', true);
        if (!$dismissedChangelog) {
            $this->renderChangelogNotice();
        } else {
            if (version_compare($dismissedChangelog, $this->pluginsVersionsProvider->getPluginVersion('builderius')) === -1) {
                $this->renderChangelogNotice();
            }
        }
    }

    private function renderChangelogNotice()
    {
        /*$url = $_SERVER['REQUEST_URI'];
        if (!strpos($url, '?')) {
            $url = sprintf('%s?builderius-changelog-dismissed', $url);
        } else {
            $url = sprintf('%s&builderius-changelog-dismissed', $url);
        }
        $html = '<div class="notice notice-info is-dismissible">
                    <p>Builderius v0.9.10 Changelog:</p>
                    <ul>
                        <li>Added Blocksy theme hooks to hook names autocomplete for "Hook Templates" </li>
                        <li>Added outline css setting</li>
                        <li>Removed Template css settings for "Hook Templates" </li>
                    </ul>
                    <a class="notice-dismiss" href="' . $url . '"><span class="screen-reader-text">Dismiss</span></a>
                </div>';

        echo $html;*/
    }
}