<?php

namespace Builderius\Bundle\SettingBundle\Validation\Exta;

use Builderius\enshrined\svgSanitize\data\AttributeInterface;

class SvgAllowedAttributes implements AttributeInterface
{
    /**
     * Returns an array of attributes
     *
     * @return array
     */
    public static function getAttributes()
    {
        return array(
            // HTML
            'about',
            'accept',
            'action',
            'align',
            'alt',
            'autocomplete',
            'background',
            'bgcolor',
            'border',
            'cellpadding',
            'cellspacing',
            'checked',
            'cite',
            'class',
            'clear',
            'color',
            'cols',
            'colspan',
            'coords',
            'crossorigin',
            'datetime',
            'default',
            'dir',
            'disabled',
            'download',
            'enctype',
            'encoding',
            'face',
            'for',
            'headers',
            'height',
            'hidden',
            'high',
            'href',
            'hreflang',
            'id',
            'integrity',
            'ismap',
            'label',
            'lang',
            'list',
            'loop',
            'low',
            'max',
            'maxlength',
            'media',
            'method',
            'min',
            'multiple',
            'name',
            'noshade',
            'novalidate',
            'nowrap',
            'open',
            'optimum',
            'pattern',
            'placeholder',
            'poster',
            'preload',
            'pubdate',
            'radiogroup',
            'readonly',
            'rel',
            'required',
            'rev',
            'reversed',
            'role',
            'rows',
            'rowspan',
            'spellcheck',
            'scope',
            'selected',
            'shape',
            'size',
            'sizes',
            'span',
            'srclang',
            'start',
            'src',
            'srcset',
            'step',
            'style',
            'summary',
            'tabindex',
            'title',
            'type',
            'usemap',
            'valign',
            'value',
            'version',
            'width',
            'xmlns',
            // SVG
            'accent-height',
            'accumulate',
            'additivive',
            'alignment-baseline',
            'alphabetic',
            'amplitude',
            'arabic-form',
            'ascent',
            'attributename',
            'attributetype',
            'azimuth',
            'basefrequency',
            'baseline-shift',
            'baseProfile',
            'bbox',
            'begin',
            'bias',
            'by',
            'calcMode',
            'cap-height',
            'class',
            'clip',
            'clipPathUnits',
            'clip-path',
            'clip-rule',
            'color',
            'color-interpolation',
            'color-interpolation-filters',
            'color-profile',
            'color-rendering',
            'contentScriptType',
            'contentStyleType',
            'crossorigin',
            'cursor',
            'cx',
            'cy',
            'd',
            'decelerate',
            'descent',
            'diffuseConstant',
            'direction',
            'display',
            'divisor',
            'dominant-baseline',
            'dur',
            'dx',
            'dy',
            'edgeMode',
            'elevation',
            'enable-background',
            'end',
            'exponent',
            'fill',
            'fill-opacity',
            'fill-rule',
            'filter',
            'filterRes',
            'filterUnits',
            'flood-color',
            'flood-opacity',
            'font-family',
            'font-size',
            'font-size-adjust',
            'font-stretch',
            'font-style',
            'font-variant',
            'font-weight',
            'format',
            'from',
            'fr',
            'fx',
            'fy',
            'g1',
            'g2',
            'glyph-name',
            'glyph-orientation-horizontal',
            'glyph-orientation-vertical',
            'glyphRef',
            'gradientTransform',
            'gradientUnits',
            'hanging',
            'height',
            'href',
            'hreflang',
            'horiz-adv-x',
            'horiz-origin-x',
            'id',
            'ideographic',
            'image-rendering',
            'in',
            'in2',
            'intercept',
            'k',
            'k1',
            'k2',
            'k3',
            'k4',
            'kernelMatrix',
            'kernelUnitLength',
            'kerning',
            'keyPoints',
            'keySplines',
            'keyTimes',
            'lang',
            'lengthAdjust',
            'letter-spacing',
            'lighting-color',
            'limitingConeAngle',
            'local',
            'marker-end',
            'marker-mid',
            'marker-start',
            'markerHeight',
            'markerunits',
            'markerWidth',
            'mask',
            'maskContentUnits',
            'maskUnits',
            'max',
            'mask',
            'media',
            'method',
            'min',
            'mode',
            'name',
            'numOctaves',
            'offset',
            'opacity',
            'operator',
            'order',
            'orient',
            'orientation',
            'origin',
            'overflow',
            'overline-position',
            'overline-thickness',
            'panose-1',
            'paint-order',
            'path',
            'pathlength',
            'patternContentUnits',
            'patternTransform',
            'patternUnits',
            'ping',
            'pointer-events',
            'points',
            'pointsAtX',
            'pointsAtY',
            'pointsAtZ',
            'preserveAlpha',
            'preserveAspectRatio',
            'primitiveUnits',
            'r',
            'radius',
            'referrerPolicy',
            'refX',
            'refY',
            'rel',
            'rendering-intent',
            'repeatCount',
            'repeatDur',
            'requiredExtensions',
            'requiredFeatures',
            'restart',
            'result',
            'rotate',
            'rx',
            'ry',
            'scale',
            'seed',
            'shape-rendering',
            'slope',
            'spacing',
            'specularConstant',
            'specularExponent',
            'speed',
            'spreadMethod',
            'startOffset',
            'stdDeviation',
            'stemh',
            'stemv',
            'stitchTiles',
            'stop-color',
            'stop-opacity',
            'strikethrough-position',
            'strikethrough-thickness',
            'string',
            'stroke',
            'stroke-dasharray',
            'stroke-dashoffset',
            'stroke-linecap',
            'stroke-linejoin',
            'stroke-miterlimit',
            'stroke-opacity',
            'stroke-width',
            'style',
            'surfaceScale',
            'systemLanguage',
            'tabindex',
            'tableValues',
            'target',
            'targetX',
            'targetY',
            'text-anchor',
            'text-decoration',
            'text-rendering',
            'textLength',
            'to',
            'transform',
            'transform-origin',
            'type',
            'u1',
            'u2',
            'underline-position',
            'underline-thickness',
            'unicode',
            'unicode-bidi',
            'unicode-range',
            'units-per-em',
            'v-alphabetic',
            'v-hanging',
            'v-ideographic',
            'v-mathematical',
            'values',
            'vector-effect',
            'version',
            'vert-adv-y',
            'vert-origin-x',
            'vert-origin-y',
            'viewBox',
            'viewTarget',
            'visibility',
            'width',
            'widths',
            'word-spacing',
            'writing-mode',
            'xchannelselector',
            'ychannelselector',
            'x',
            'x-height',
            'x1',
            'x2',
            'xChannelSelector',
            'xlink:actuate',
            'xlink:arcrole',
            'xlink:href',
            'xlink:role',
            'xlink:show',
            'xlink:title',
            'xlink:type',
            'xml:base',
            'xml:lang',
            'xml:space',
            'y',
            'y1',
            'y2',
            'yChannelSelector',
            'z',
            'zoomAndPan',
            // MathML
            'accent',
            'accentunder',
            'actiontype',
            'align',
            'bevelled',
            'close',
            'columnalign',
            'columnlines',
            'columnspacing',
            'columnspan',
            'denomalign',
            'depth',
            'dir',
            'display',
            'displaystyle',
            'fence',
            'frame',
            'framespacing',
            'height',
            'href',
            'id',
            'length',
            'linethickness',
            'lspace',
            'lquote',
            'mathbackground',
            'mathcolor',
            'mathsize',
            'mathvariant',
            'maxsize',
            'minsize',
            'movablelimits',
            'notation',
            'numalign',
            'open',
            'rowalign',
            'rowlines',
            'rowspacing',
            'rowspan',
            'rspace',
            'rquote',
            'scriptlevel',
            'scriptminsize',
            'scriptsizemultiplier',
            'selection',
            'separator',
            'separators',
            'stretchy',
            'subscriptshift',
            'supscriptshift',
            'symmetric',
            'voffset',
            'width',
            'xmlns',
            // XML
            'xml:id',
            'xmlns:xlink',
        );
    }
}