<?php

namespace Builderius\Mustache;

/**
 * Mustache Cache interface.
 *
 * Interface for caching and loading Template classes
 * generated by the Compiler.
 */
interface Cache
{
    /**
     * Load a compiled Template class from cache.
     *
     * @param string $key
     *
     * @return bool indicates successfully class load
     */
    public function load($key);
    /**
     * Cache and load a compiled Template class.
     *
     * @param string $key
     * @param string $value
     */
    public function cache($key, $value);
    /**
     * Set a logger instance.
     *
     * @param Logger $logger
     */
    public function setLogger($logger = null);
}
